C
C**********************************************************************
C
C                       STARTPM v3.10 4/10/89
C
C***********************************************************************
C
      SUBROUTINE STARTP(IBIG)
C
C     DRIVER FOR HITACHI 672 A3 PLOTTER
C
C     INTERFACE SUBROUTINE LIKE OLD FORTLIB TO WRITE
C     PLOTTER FILES TO UNIT 8.THE SCALE IS SET INITIALLY
C     TO 1 UNIT TO 1MM.IBIG=0 USES A4,IBIG=1 USES A3.
C     THE NAME OF THE PLOT FILE IS PLOTEM,AND SHOULD
C     BE PRINTED TO THE PLOTTER AS IF IT WHERE A PRINT
C FILE
C
      SAVE
      COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
      COMMON /PAPER/ IBG
      CHARACTER*9 PNAME,SNAME,R1*24
      CHARACTER*1 NUM(10),PFILE(9),SFILE(9)
      EQUIVALENCE (PNAME,PFILE(1)),(SNAME,SFILE(1))
      DATA NUM/'0','1','2','3','4','5','6','7','8','9'/
      DATA PFILE/'p','l','o','t','e','m','.','0','1'/
      DATA SFILE/'s','c','r','e','e','n','.','0','1'/
      DATA XOR,YOR/0.,0./
      DATA IPNUM/0/
      DATA SX,SY/1.,1./
C
      INSTR=2
C
C       SETTING FILE UNIT NUMBERS
C
      IPOUT = 8
      IMOUT = 9
      IDOUT = 10
      ITOUT = 12
      IFOUT = 14
C
      OPEN(UNIT=ITOUT,FILE='table',STATUS='UNKNOWN')
      WRITE(ITOUT,*) SNAME
      WRITE(ITOUT,*) PNAME
100   FORMAT(' ',A9)
      IBG = IBIG
      IPNUM = IPNUM + 1
      IFL = 1
      GOTO 10
C
C       CLOSES PLOT AND SCREEN FILE, INCREMENTS THE COUNTER IPNUM, OPENS
C       NEW PLOT AND SCREEN FILES, WRITES NAMES TO FILE 'TABLE'
C
      ENTRY PICCLE
C
C       RESETS ORIGIN
C
      XOR=0.
      YOR = 0.
C
C       WRITES OUT TIME AND DATE
C
      YP = 5.
      XP = 234.
      IF(IBG.EQ.1) XP=379.
      WRITE(IPOUT,103)
      WRITE(IPOUT,205)
      WRITE(IPOUT,210) XP,YP
      WRITE(IMOUT,*) 1,90
      WRITE(IMOUT,*) 4,0,0
      WRITE(IPOUT,*) 'SI'
      IF (IBG.EQ.0) THEN
        CYS = 1.77
      ELSE
        CYS = 2.85
      ENDIF
      WRITE(IMOUT,*) 3,0,CYS
      WRITE(IMOUT,*) 2,XP,YP
      CALL FDATE(R1)
      WRITE(IPOUT,310)
      WRITE(IPOUT,320) R1
      WRITE(IPOUT,205)
      XP = 0.
      YP = 0.
      WRITE(IPOUT,210) XP,YP
      CLOSE (IPOUT)
      CLOSE (IDOUT)
      CLOSE (IMOUT)
      IPNUM = IPNUM + 1
      ITEN = IPNUM / 10
      IDIG = IPNUM - 10 * ITEN
      PFILE(8) = NUM(ITEN + 1)
      SFILE(8) = PFILE(8)
      PFILE(9) = NUM(IDIG + 1)
      SFILE(9) = PFILE(9)
      WRITE(ITOUT,*) SNAME
      WRITE(ITOUT,*) PNAME
C
10    CONTINUE
      OPEN(UNIT=IPOUT,FILE=PNAME,STATUS='UNKNOWN')
      OPEN(UNIT=IDOUT,FILE=SNAME,STATUS='UNKNOWN')
      OPEN(UNIT=IMOUT,FILE=PNAME//'I',STATUS='UNKNOWN')
      M = 1
      WRITE(IDOUT,305) M+2
      WRITE(IMOUT,*) M+3,0,0
      WRITE(IPOUT,101)
101   FORMAT('IN;')
      WRITE(IPOUT,102)
102   FORMAT('VS 1;')
103   FORMAT('VS 11;')
      IF (IBG.EQ.0) THEN
C
C     A4 PAPER
C
        WRITE(IPOUT,105)
105     FORMAT('IP 0 0 10800 6800;')
        WRITE(IPOUT,108)
108     FORMAT('PS 4;')
C
C       SETS SCALE TO 1 UNIT TO 1 MM
C
        WRITE(IPOUT,110)
110     FORMAT('SC 0 235 0 169;')
      ELSEIF (IBG.EQ.1) THEN
C
C     A3 PAPER
C
        WRITE(IPOUT,115)
115     FORMAT('IP 0 0 15200 10800;')
        WRITE(IPOUT,118)
118     FORMAT('PS 0;')
C
C       SETS SCALE TO 1 UNIT TO 1 MM
C
        WRITE(IPOUT,120)
120     FORMAT('SC 0 380 0 270;')
      ENDIF
C
C     SETS SYMBOL WHICH ENDS CHARACTER STRING TO 
C
      WRITE(IPOUT,130)
130   FORMAT('DT;')
C
C     SETS PEN TO BLACK
C
      M = 1
      WRITE(IPOUT,300) M
C
C     SETS DEFAULT LINE WIDTH TO 3 (FREELANCE `C`)
C
      WRITE(IDOUT,217) 3.,0.,-10
C
C     SETS CHARACTER SCALE TO 1.8 MM (WIDTH),2.5 MM(HEIGHT)
C
      XC = .18
      YC = .25
      WRITE(IPOUT,140) XC,YC
140   FORMAT('SI ',F5.2,' ',F5.2,';')
      WRITE(IMOUT,*) 3,0,10.*YC
      RETURN
C
C     SETS NEW ORIGIN AT X,Y IN USER UNITS RELATIVE TO
C     PREVIOUS ORIGIN
C
      ENTRY ORIGIN(X, Y)
      XOR=XOR+X*SX
      YOR = YOR + Y * SY
      RETURN
C     SETS NEW LINE WIDTH (FOR METAFILE ONLY)
C     PARAMETER IS INTEGER*4 RANGE 1 TO 5 INCLUSIVE
C     NOT VALUE CHECKED
C       ENTRY VALUE             METAFILE OUTPUT BYTES
C         1                       50 62 00 01(HEX)
C         2                       50 62 00 1E  "
C         3                       50 62 00 50  "
C         4                       50 62 00 AF  "
C         5                       50 62 01 13  "
C
      ENTRY LWIDTH(N)
      WRITE(IDOUT,217) N*1.,0.,-10
217   FORMAT(' ',F7.2,' ',F7.2,' ',I3)
      RETURN
C
C     MOVES WITH PEN UP TO X,Y FOR DRAWING CHARACTERS
C     N MUST BE 2
C
      ENTRY LOCCHR(X, Y, N)
      ILOC = 1
      GOTO 30
C
C     MOVES PEN TO X,Y,SCALED IF SX,SY ARE NOT 1.,RELATIVE TO
C     CURRENT ORIGIN WITH PEN UP IF N=2,DOWN IF N=0
C
      ENTRY PLOT(X, Y, N)
      ILOC = 0
30    IF(N.EQ.0) WRITE(IPOUT,200)
200   FORMAT('PD;')
      IF (N.EQ.2) THEN
        WRITE(IPOUT,103)
        WRITE(IPOUT,205)
205     FORMAT('PU;')
      ENDIF
      XP=X*SX+XOR
      YP = Y * SY + YOR
      WRITE(IPOUT,210) XP,YP
210   FORMAT('PA ',F7.2,' ',F7.2,';')
      IF(N.EQ.2) WRITE(IPOUT,102)
      M = 0
      IF(N.EQ.0) M=1
      WRITE(IDOUT,215) XP,YP,M
215   FORMAT(' ',F7.2,' ',F7.2,' ',I1)
      IF (ILOC.EQ.1) THEN
      WRITE(IMOUT,216) XP,YP
216   FORMAT(' 2,',F7.2,',',F7.2)
      ENDIF
      RETURN
C
C     SETS CHARACTER SIZE TO XS WIDTH,YS HEIGHT IN MM
C
      ENTRY SCLCHR(XS, YS)
      XC = XS / 10.
      YC = YS / 10.
      WRITE(IPOUT,140) XC,YC
      WRITE(IMOUT,*) 3,0,YS
      RETURN
C
C     SETS NEW SCALE ,1 USER UNIT=XS MM IN X DIR.,=YS IN Y
C
      ENTRY SCAL(XS, YS)
      SX = XS
      SY = YS
      RETURN
C
C     WRITES CHARACTERS AT AN ANGLE A IN DEGREES TO THE X AXIS
C
      ENTRY ROTCHR(AROT)
      A = AROT
      B = A
      A = A * 3.14159 / 180.
      DX = COS(A)
      DY = SIN(A)
      WRITE(IPOUT,400) DX,DY
400   FORMAT('DI ',F5.2,' ',F5.2,';')
      WRITE(IMOUT,*) 1,B,0
      RETURN
C
C     CHANGES PEN COLOUR.N=1,SET INITIALLY,BLACK
C                        N=2 RED
C                        N=3 GREEN
C                        N=7 BLUE
C
      ENTRY PEN(N)
      M = N
      IF(M.EQ.7) M=4
      WRITE(IPOUT,300) M
300   FORMAT('SP ',I1,';')
      WRITE(IDOUT,305) M+2
305   FORMAT('0,0,',I1)
      WRITE(IMOUT,306) M+3
306   FORMAT(I1,',0,0')
      RETURN
C
C     FINISHES PLOT AND CLOSES FILE
C
      ENTRY ENGPLT
      YP = 5.
      XP = 234.
      IF(IBG.EQ.1) XP=379.
      WRITE(IPOUT,103)
      WRITE(IPOUT,205)
      WRITE(IPOUT,210) XP,YP
      WRITE(IMOUT,*) 1,90
      WRITE(IMOUT,*) 4,0,0
      WRITE(IPOUT,*) 'SI'
      IF (IBG.EQ.0) THEN
      CYS = 1.77
      ELSE
      CYS = 2.85
      ENDIF
      WRITE(IMOUT,*) 3,0,CYS
      WRITE(IMOUT,*) 2,XP,YP
C      CALL FDATE(R1)
      WRITE(IPOUT,310)
      WRITE(IPOUT,320) R1
310   FORMAT('DI 0 1 ;')
320   FORMAT('LB ',A24,' ')
      WRITE(IPOUT,205)
      XP = 0.
      YP = 0.
      WRITE(IPOUT,210) XP,YP
      CLOSE (IPOUT)
      CLOSE (IDOUT)
      WRITE(ITOUT,330)
330   FORMAT('END')
      CLOSE (ITOUT)
      CLOSE (IMOUT)
      IF(INSTR.GE.1) CALL FRELNC
      RETURN
C        ENTRY FILL
C Sets fill to I
C Valid fills are.
C       1       Solid
C       2       Narrow crosshatch
C       3       Narrow top right-bottom left lines
C       4       Narrow top left -bottom right lines
C       5       Wide version of 2
C       6       Wide version of 3
C       7       Wide version of 4
C       8       Empty
C       9       Solid
C       10      75% grey
C       11      50% grey
C       12      25% grey
C       13      12% grey
C       14      6%  grey

      ENTRY FILL(N)
      WRITE(IDOUT,*) N,0,12
      RETURN

C       ENTRY CIRCLE
C       Draws circle center X,Y radius R
C       Is a lot faster than drawing the same polyline and
C       Has the facilities for Filling it in (see ENTRY FILL above)

      ENTRY CIRCLE(X,Y,R)
      XP=X*SX+XOR
      YP = Y * SY + YOR
      RU=R*SX
      WRITE(IDOUT,*) XP,YP,13
      WRITE(IDOUT,*) RU,0,14
      RETURN


      ENTRY POLY(X,Y,N)
      IF (N.EQ.0) M=21
      IF (N.EQ.2) M=20
      XP=X*SX+XOR
      YP = Y * SY + YOR
      WRITE(IDOUT,*) XP,YP,M
      RETURN

      END



C
C***************************************************************************
C
       SUBROUTINE FRELNC
C
C       WRITES FREELANCE METAFILE V2.0
C
       COMMON /FLNCE/ SNAME, PNAME
       COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
       DIMENSION ICGMD(592)
       CHARACTER*9 PNAME,SNAME,META*11,ICGMC*1,SNME(9)*1
       EQUIVALENCE (SNME(1),SNAME)
C
       DATA ICGMD/000,046,013,068,058,092,087,076,092,069,088,054,
     C 046,083,084,079,016,034,000,001,016,094,028,070,114,101,101,
     C 108,097,110,099,101,032,077,101,116,097,102,105,108,101,032,
     C 086,101,114,
     C 115,105,111,110,032,050,000,016,098,000,000,016,130,000,016,
     C 016,166,000,001,000,016,000,016,016,194,000,016,016,226,000,
     C 016,017,002,000,016,017,034,000,016,017,076,000,000,000,000,
     C 000,000,000,100,000,100,000,100,017,127,000,222,000,055,000,
     C 000,000,001,000,000,000,002,000,000,000,003,000,000,000,004,
     C 000,000,000,005,000,001,000,001,000,001,000,002,000,001,000,
     C 003,000,001,000,004,000,001,000,005,000,001,000,006,000,001,
     C 000,008,000,001,000,009,000,001,000,013,000,002,000,001,000,
     C 002,000,002,000,002,000,003,000,002,000,004,000,002,000,005,
     C 000,002,000,006,000,003,000,001,000,003,000,004,000,003,000,
     C 006,000,004,000,001,000,004,000,003,000,004,000,004,000,004,
     C 000,007,000,004,000,011,000,004,000,012,000,004,000,015,000,
     C 004,000,016,000,004,000,017,000,004,000,018,000,004,000,019,
     C 000,005,000,002,000,005,000,003,000,005,000,004,000,005,000,
     C 006,000,005,000,007,000,005,000,008,000,005,000,010,000,005,
     C 000,014,000,005,000,015,000,005,000,016,000,005,000,018,000,
     C 005,000,022,000,005,000,023,000,005,000,024,000,005,000,027,
     C 000,005,000,028,000,005,000,029,000,005,000,030,000,005,000,
     C 034,000,006,000,001,000,007,000,002,017,191,000,108,005,083,
     C 119,105,115,115,012,083,119,105,115,115,032,082,097,115,116,
     C 101,114,012,083,119,105,115,115,032,082,097,115,116,101,114,
     C 012,083,119,105,115,115,032,082,097,115,116,101,114,012,083,
     C 119,105,115,115,032,082,097,115,116,101,114,021,071,111,116,
     C 104,105,099,032,069,110,103,108,105,115,104,032,083,116,114,
     C 111,107,101,012,083,101,114,105,102,032,083,116,114,111,107,
     C 101,013,083,099,114,105,112,116,032,083,116,114,111,107,101,
     C 000,112,068,076,066,001,001,000,106,008,080,073,067,084,085,
     C 082,069,049,000,032,038,000,000,000,000,000,000,032,066,000,
     C 000,032,098,000,000,032,130,000,000,032,162,000,000,032,200,
     C 000,000,000,000,127,255,092,113,000,128,084,095,000,074,000,
     C 001,000,000,000,000,000,000,000,014,000,040,000,071,000,000,
     C 000,063,000,024,000,084,000,014,000,014,000,100,000,000,000,
     C 040,000,000,000,000,000,000,000,014,000,040,000,071,000,000,
     C 000,079,000,094,000,097,000,092,000,000,000,100,000,000,000,
     C 040,000,000,000,063,000,024,000,100,000,100,000,100,048,034,
     C 000,016,048,130,000,001,048,194,000,000,080,130,000,001,080,
     C 066,000,001,080,098,000,001/
C
C
       OPEN(UNIT=ITOUT,FILE='table',STATUS='OLD',ERR=100)
12     READ(ITOUT,*) SNAME
       IF (SNAME.EQ.'END') GO TO 15
       READ(ITOUT,*) PNAME
       WRITE(*,*) 'Building metafile '//SNME(8)//SNME(9)
       META='metafile.'//SNME(8)//SNME(9)
       OPEN(UNIT=IFOUT,FILE=META,STATUS='UNKNOWN',
     C ACCESS='SEQUENTIAL')
C
       DO 10 I=1,592
         ICGMC = CHAR(ICGMD(I))
         WRITE(IFOUT,1001) ICGMC
10     CONTINUE
       CALL LINES
       CALL LABELS
        WRITE(IFOUT,1001)  CHAR(00)
        WRITE(IFOUT,1001)  CHAR(160)
        WRITE(IFOUT,1001)  CHAR(00)
        WRITE(IFOUT,1001)  CHAR(64)
        CLOSE (IFOUT)
       GOTO 12
15     CLOSE (ITOUT)
       WRITE(*,*) 'Done'
       RETURN
C       STOP
1001   FORMAT(A1,$)
C
C
100    WRITE(*,*)'Cannot find data file TABLE. , metafile incomplete.'
       RETURN
C       STOP
       END
C
C****************************************************************************
C
       SUBROUTINE CRD(X1, Y1)
C
C       Converts real variables x1 and y1 into a Character*4 metatfile format.
C
       COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
       X = X1 + 40
       Y = Y1 + 40
       X = X * 70
       Y = Y * 70
       IX1 = X / 256
       IX2 = X - IX1 * 256
       IY1 = Y / 256
       IY2 = Y - IY1 * 256
        WRITE(IFOUT,1001) CHAR(IX1)
        WRITE(IFOUT,1001) CHAR(IX2)
        WRITE(IFOUT,1001) CHAR(IY1)
        WRITE(IFOUT,1001) CHAR(IY2)
       RETURN
1001   FORMAT(A1,$)
       END
C
C****************************************************************************
C
       SUBROUTINE CIRCRD(X1, Y1, R1)
C
C
       COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
       X = X1 +40
       Y = Y1 +40
       R = R1
       X = X * 70
       Y = Y * 70
       R = R * 70
       IX1 = X / 256
       IX2 = X - IX1 * 256
       
       IY1 = Y / 256
       IY2 = Y - IY1 * 256

       IR1 = R / 256
       IR2 = R - IY1 * 256
       
        WRITE(IFOUT,1001) CHAR(IX1)
        WRITE(IFOUT,1001) CHAR(IX2)
        WRITE(IFOUT,1001) CHAR(IY1)
        WRITE(IFOUT,1001) CHAR(IY2)
        WRITE(IFOUT,1001) CHAR(IR1)
        WRITE(IFOUT,1001) CHAR(IR2)
       RETURN
1001   FORMAT(A1,$)
       END
C
C***************************************************************
C
       SUBROUTINE LINES
C
C      Reads through the file SNAME and converts it to
C      Frelance format.
C
C	FORMAT FOR SNAME
C	X,Y,N WHERE X,Y,N ARE REAL OR INTEGER
C	
C	COMMANDS
C	N=-10 SET LINE WIDTH TO X
C	N=0 START NEW LINE AT X,Y
C	N=1 CONTINUE LINE TO X,Y
C	N=2 RESERVED
C	N=3 SET COLOR TO 1(BLACK)
C	N=4 SET COLOR TO 4(RED)
C	N=5 SET COLOR TO 3(BLACK)
C	N=6 SET COLOR TO 2(BLUE)
C	N=8 RESERVED
C	N=9 RESERVED
C	N=12 SET FILL TO EQUAL X (SEE ENTRY FILL IN STARTPM)
C	N=13 DRAW A CIRCLE AT X,Y RADIUS X OF NEXT RECORD.
C	N=20 START NEW POLYGON AT X,Y
C	N=21 CONTINUE POLYGON TO X,Y
C	ALL OTHER VALUES OF N ARE FREE FOR EXPANSION
C
C
C
       COMMON /FLNCE/ SNAME, PNAME
       COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
       DIMENSION AX(0:50000),AY(0:50000)
       DIMENSION IFILL1(14),IFILL2(14),IFILL3(14)
        DATA IFILL1/-1,00,00,00,00,00,00,00,-1,255,255,255,255,255/
        DATA IFILL2/-1,06,03,04,01,02,05,05,-1,246,245,244,243,241/
        DATA IFILL3/01,03,03,03,03,03,03,04,01,003,003,003,003,003/

       CHARACTER*9 SNAME,PNAME
       IPOLY=1
       ILINE=2
       IQUER=0
       ILAST=IQUER
       IFILL=7
       ITOOLN=0
       IFEO = 0
       OX = 0
       OY = 0
	ICIRC=1
	ILIC=0

C

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(01)       

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(98)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(01)       

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(98)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(01)       

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(194)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(01)       

       OPEN(UNIT=IDOUT,FILE=SNAME,STATUS='OLD',ERR=100)
 


30	READ(IDOUT,*,END=110) X, Y, IN
31      CONTINUE

        IF (IN.EQ.-10) THEN
         WRITE(IFOUT,1001) CHAR(80)
         WRITE(IFOUT,1001) CHAR(98)
         IF (X.EQ.1) THEN
           IWID1=0
           IWID2=1
         END IF
         IF (X.EQ.2) THEN
           IWID1=0
           IWID2=30
         END IF
         IF (X.EQ.3) THEN
           IWID1=0
           IWID2=80
         END IF
         IF (X.EQ.4) THEN
           IWID1=0
           IWID2=175
         END IF
         IF (X.EQ.5) THEN
           IWID1=1
           IWID2=19
         END IF
         WRITE(IFOUT,1001) CHAR(IWID1)
         WRITE(IFOUT,1001) CHAR(IWID2)       
         GOTO 30
        END IF

       IF ((IN.GT.2).AND.(IN.LT.10)) THEN
	ICIRC=IN-2
	GOTO 30
       END IF

       IF (IN.EQ.12) THEN
         IFILL=X
         GOTO 30
       END IF



       IF (IN.EQ.13) THEN
         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(IWID1)
         WRITE(IFOUT,1001) CHAR(IWID2)       

	IF (ILIC.NE.ICIRC) THEN
         ICD=ICIRC
	 ILIC=ICIRC
	 IF(ICIRC.EQ.2) ICD=4
         IF(ICIRC.EQ.4) ICD=2
         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(162)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(82)
         WRITE(IFOUT,1001) CHAR(226)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(80)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(0)
         WRITE(IFOUT,1001) CHAR(ICD)
	END IF 

         IF(IFILL1(IFILL).NE.-1) THEN
          WRITE(IFOUT,1001) CHAR(83)
          WRITE(IFOUT,1001) CHAR(02)
          WRITE(IFOUT,1001) CHAR(IFILL1(IFILL))
          WRITE(IFOUT,1001) CHAR(IFILL2(IFILL))       
         END IF

         WRITE(IFOUT,1001) CHAR(82)
         WRITE(IFOUT,1001) CHAR(194)
         WRITE(IFOUT,1001) CHAR(0)
         WRITE(IFOUT,1001) CHAR(IFILL3(IFILL))       

         READ(IDOUT,*,END=110) R, DUMMY1, DUMMY2
         WRITE(IFOUT,1001) CHAR(65)
         WRITE(IFOUT,1001) CHAR(134)
         CALL CIRCRD(X,Y,R)
         GOTO 30
        END IF
 	
40 	CONTINUE
       IF (IN.EQ.1) THEN
	IF (ITOOLN.EQ.1) THEN
	 AX(0)=AX(50000)
	 AY(0)=AX(50000)
	 WRITE(*,*) 'MOOCHECK #1'
        ELSE
 	 WRITE(*,*) 'Hmm seems there is a line with no begining here...'
	ENDIF
        IN=0
       END IF

       IF (IN.EQ.0) THEN
	ICU=0
	IF (ITOOLN.EQ.1) THEN
	 WRITE(*,*) 'MOOCHECK #2'
	 ITOOLN=0
	 ICU=1
	ENDIF
 	
	AX(ICU)=X
	AY(ICU)=Y
41      READ(IDOUT,*,END=49) X, Y, IN

	IF (IN.NE.1) GOTO 42
	
	ICU=ICU+1
	AX(ICU)=X
	AY(ICU)=Y


	IF (ICU.EQ.50000) THEN
	  ITOOLN=1
	  WRITE(*,*) 'Warning line too long: split into two bits...'
	  GOTO 42
        ENDIF


	GOTO 41

49	IFEO=1
	GOTO 42

42      CONTINUE
        IF (ICU.GT.0) THEN

         IF (ILIC.NE.ICIRC) THEN
 	  ILIC=ICIRC
          ICD=ICIRC
          IF(ICIRC.EQ.2) ICD=4
          IF(ICIRC.EQ.4) ICD=2


         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(162)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(82)
         WRITE(IFOUT,1001) CHAR(226)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(80)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(0)
         WRITE(IFOUT,1001) CHAR(ICD)
	 ENDIF

         INOC = ICU + 1
         JIU = 32 + (INOC * 4)
         WRITE(IFOUT,1001) CHAR(64)
         IF (JIU.GT.63) THEN
           WRITE(IFOUT,1001)  CHAR(63)
           JIG = JIU - 32
           JIM = JIG / 256
           JIN = JIG - JIM * 256
           WRITE(IFOUT,1001) CHAR(JIM)
           WRITE(IFOUT,1001) CHAR(JIN)
         ENDIF
         IF (JIU.LT.61) THEN
           WRITE(IFOUT,1001)  CHAR(JIU)
         ENDIF
         DO 43 NI=0,ICU
           CALL CRD(AX(NI), AY(NI))
43       CONTINUE
       ENDIF
      IF (IFEO.EQ.0) GOTO 31	 
      ENDIF

       IF (IN.EQ.20) THEN
	ICU=0
	AX(ICU)=X
	AY(ICU)=Y
51      READ(IDOUT,*,END=59) X, Y, IN

	IF (IN.NE.21) GOTO 52
	
	ICU=ICU+1
	AX(ICU)=X
	AY(ICU)=Y
	GOTO 51

59	IFEO=1
	GOTO 52

52  	CONTINUE
        IF (ICU.GT.0) THEN

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(IWID1)
         WRITE(IFOUT,1001) CHAR(IWID2)       

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(98)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(01)       

         IF(IFILL1(IFILL).NE.-1) THEN
          WRITE(IFOUT,1001) CHAR(83)
          WRITE(IFOUT,1001) CHAR(02)
          WRITE(IFOUT,1001) CHAR(IFILL1(IFILL))
          WRITE(IFOUT,1001) CHAR(IFILL2(IFILL))       
         END IF

         WRITE(IFOUT,1001) CHAR(82)
         WRITE(IFOUT,1001) CHAR(194)
         WRITE(IFOUT,1001) CHAR(0)
         WRITE(IFOUT,1001) CHAR(IFILL3(IFILL))       

         IF (ILIC.NE.ICIRC) THEN
 	  ILIC=ICIRC
          ICD=ICIRC
          IF(ICIRC.EQ.2) ICD=4
          IF(ICIRC.EQ.4) ICD=2

         WRITE(IFOUT,1001) CHAR(83)
         WRITE(IFOUT,1001) CHAR(162)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(82)
         WRITE(IFOUT,1001) CHAR(226)
         WRITE(IFOUT,1001) CHAR(00)
         WRITE(IFOUT,1001) CHAR(ICD)       

         WRITE(IFOUT,1001) CHAR(80)
         WRITE(IFOUT,1001) CHAR(130)
         WRITE(IFOUT,1001) CHAR(0)
         WRITE(IFOUT,1001) CHAR(ICD)

	 ENDIF

         INOC = ICU + 1
         JIU = 224 + (INOC * 4)
         WRITE(IFOUT,1001) CHAR(64)
         IF (JIU.GT.255) THEN
           WRITE(IFOUT,1001)  CHAR(63)
           JIG = JIU - 224
           JIM = JIG / 256
           JIN = JIG - JIM * 256
           WRITE(IFOUT,1001) CHAR(JIM)
           WRITE(IFOUT,1001) CHAR(JIN)
         ENDIF
         IF (JIU.LT.255) THEN
           WRITE(IFOUT,1001)  CHAR(JIU)
         ENDIF
         DO 53 NI=0,ICU
           CALL CRD(AX(NI), AY(NI))
53       CONTINUE
       ENDIF
      GOTO 31	 
      ENDIF
      IF (IFEO.EQ.0) THEN
       WRITE(*,*) 
     C "Illegal command in file screen.xx. Attempting to recover"
       WRITE(*,*) "=> ",X,Y,IN
      END IF

60    IF (IFEO.EQ.0) GOTO 30

       CLOSE (IDOUT)
       RETURN
C




1001   FORMAT(A1,$)

100    WRITE(*,*)
     C 'Cannot find data file SCREEN.xx , metafile incomplete.'
       RETURN
C
110    IFEO = 1
       GOTO 60
       END
C
C*****************************************************************************
C
       SUBROUTINE LABELS
C
C      Reads through file PNAME and PNAME//'I' and writes labels
C      to the metafile
C      FORMAT OF PNAME//'I'
C      I4  R4  R4
C      1   XR  YR  ROTATE BY XR DEGREES CLOCKWISE
C      2   X   Y   MOVE TO X,Y THEN FIND LABEL IN PLOTEM FILE
C      3   X   Y   CHARACTERS ARE HEIGHT Y millimeters
C      4   -   -   PEN 1
C      5   -   -   PEN 2
C      6   -   -   PEN 3
C      7   -   -   PEN 4
C
       COMMON /FLNCE/ SNAME, PNAME
       COMMON /FILENM/ IPOUT, IMOUT, IDOUT, ITOUT, IFOUT, INSTR
       COMMON /PAPER/ IBG
       CHARACTER*9 SNAME,PNAME,PT1*2,PT2*79,P2(79)*1
       EQUIVALENCE (PT2,P2(1))
       INTEGER*4 IDEG(33),IR(4)
       DATA IDEG/081,066,000,001,081,226,002,
     C 203,082,008,000,000,002,203,002,
     C 203,000,000,082,076,000,001,000,002,000,000,000,000,000,000,
     C 000,000,064/
       CFAC = 3.1415926 / 180.
       ICOL = 1
       IF (IBG.EQ.0) THEN
         CYS = 1.77
       ELSE
         CYS = 2.85
       ENDIF
       OPEN(UNIT=IPOUT,FILE=PNAME,STATUS='OLD',ERR=100)
       OPEN(UNIT=IMOUT,FILE=PNAME//'I',STATUS='OLD',ERR=105)
       TH = 0
C
60     READ(IPOUT,500,END=90) PT1,PT2
500    FORMAT(A2,A79)
       IF (PT1.NE.'LB') GO TO 60
       ITERM = -1
       DO 70 I=1,79
         IF (P2(I).EQ.'') ITERM=I
         IF (P2(I).EQ.'') ITERM=I
70     CONTINUE
       IF (ITERM.EQ. - 1) THEN
         WRITE(*,*)'WARNING - Label terminated incorrectly, ignored.'
         GOTO 60
       ENDIF
       P2(ITERM)=' '
       ITERM = ITERM - 1
80     READ(IMOUT,*,END=106) N,X,Y
       IF (N.EQ.1) THEN
         TH = X
         GOTO 80
       ENDIF
       IF (N.EQ.3) THEN
         CYS = Y
         GOTO 80
       ENDIF
       IF (N.GT.3) THEN
         ICOL = N - 3
         GOTO 80
       ENDIF
       IF (N.NE.2) GOTO 107
       WRITE(IFOUT,1001) CHAR(81)
       WRITE(IFOUT,1001) CHAR(194)
       WRITE(IFOUT,1001) CHAR(0)
       ICD=ICOL
       IF(ICOL.EQ.2) ICD=4
       IF(ICOL.EQ.4) ICD=2
       WRITE(IFOUT,1001) CHAR(ICD)
C
       DO 81 I=1,6
         WRITE(IFOUT,1001) CHAR(IDEG(I))
81     CONTINUE
C
       Y = Y + CYS
       CY = CYS * 141
       IY = IFIX(CY)
       IS1 = IY / 256
       IS2 = IY - IS1 * 256
       WRITE(IFOUT,1001) CHAR(IS1)
       WRITE(IFOUT,1001) CHAR(IS2)

C
       DO 82 I=9,10
         WRITE(IFOUT,1001) CHAR(IDEG(I))
82     CONTINUE
C
       RTH = TH * CFAC
       IR(1) = -SIN(RTH) * CY
       IR(2) = COS(RTH) * CY
       IR(3) = IR(2)
       IR(4) = SIN(RTH) * CY
C
       DO 83 I=1,4
         IF (IR(I).LT.0) IR(I)=65536+IR(I)
         IS1 = IR(I) / 256
         IS2 = IR(I) - IS1 * 256
         WRITE(IFOUT,1001) CHAR(IS1)
         WRITE(IFOUT,1001) CHAR(IS2)
83     CONTINUE
C
       DO 84 I=19,33
         WRITE(IFOUT,1001) CHAR(IDEG(I))
84     CONTINUE
C
       IQ = ITERM
       IW = IQ / 2
       IM = (IQ + 1) / 2
       IZ = (IQ + 1) - IM * 2
       IW = IW * 2
       IW = IW + 136
C
       IF (IW.GT.159) THEN
         WRITE(IFOUT,1001) CHAR(159)
         IW = IW - 128
         IW1 = IW / 256
         IW2 = IW - IW1 * 256
         WRITE(IFOUT,1001) CHAR(IW1)
         WRITE(IFOUT,1001) CHAR(IW2)
       ELSE
         WRITE(IFOUT,1001) CHAR(IW)
       ENDIF
       CALL CRD(X, Y)
       WRITE(IFOUT,1001) CHAR(0)
       WRITE(IFOUT,1001) CHAR(1)
       WRITE(IFOUT,1001) CHAR(ITERM)
       DO 85 I=1,ITERM
         WRITE(IFOUT,1001) P2(I)
85     CONTINUE
       IF (IZ.EQ.1) WRITE(IFOUT,1001) CHAR(0)  
       GOTO 60
90     CONTINUE
       CLOSE (IMOUT,STATUS='DELETE')
       IF(INSTR.EQ.1) CLOSE (IPOUT,STATUS='DELETE')
       IF(INSTR.EQ.2) CLOSE (IPOUT)
       RETURN
C
1001   FORMAT(A1,$)
100    WRITE(*,*)
     C 'Cannot find data file PLOTEM.xx , metafile incomplete.'
       RETURN
C
105    WRITE(*,*)
     C 'Cannot find data file PLOTEM.xxI , metafile incomplete.'
       RETURN
C
106    WRITE(*,*)
     C 'End reached too soon in file PLOTEM.xxI, label ignored.'
       RETURN
C
107    WRITE(*,*)
     C 'Illegal data in file PLOTEM.xxI ,label ignored.'
       RETURN
       END

